Morph subclass: #InstanceClassSwitchMorph
	instanceVariableNames: 'instance class choice frame '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements-UI'!

!InstanceClassSwitchMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 00:11'!
arrangePanes

	| toggleWidth |
	toggleWidth _ self width - 6 // 2.

	instance 
		width: toggleWidth;
		position: self topLeft + 2;
		fitMorphs.

	class 
		width: toggleWidth;
		position: instance right + 2 @ (instance top);
		fitMorphs.

	self height: class bottom + 2 - self top! !

!InstanceClassSwitchMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 00:17'!
buildPanes

	instance _ ElementsToggleButtonMorph new
				target: self;
				selector: #instance;
				label: 'instance';
				onColor: Color blue darker offColor: color.

	class _ ElementsToggleButtonMorph new
				target: self;
				selector: #class;
				label: 'class';
				onColor: Color magenta twiceDarker offColor: color.

	self
		addMorph: instance;
		addMorph: class
! !

!InstanceClassSwitchMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 00:12'!
choice
	^choice! !

!InstanceClassSwitchMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 23:28'!
class
	(choice = #class) ifTrue: [^self].
	choice _ #class.
	frame ifNotNil: [
		frame switchToClassSide.
		self refresh ]! !

!InstanceClassSwitchMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 23:19'!
frame: aMorph
	frame _ aMorph! !

!InstanceClassSwitchMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 00:07'!
initialize
	super initialize.
	choice _ #instance.
	color _ Color gray.
	self width: 180.
	self buildPanes.
	self arrangePanes.
	self refresh! !

!InstanceClassSwitchMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 23:29'!
instance
	(choice = #instance) ifTrue: [^self].
	choice _ #instance.
	frame ifNotNil: [
		frame switchToInstanceSide.
		self refresh ]! !

!InstanceClassSwitchMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 00:13'!
refresh

	instance off.
	class off.

	(#instance = choice) ifTrue: [
		instance on ].
	(#class = choice) ifTrue: [
		class on ].

! !
